program indexserver;

{ $define usecgi}

uses
{$ifdef usecgi}
  fpcgi,
{$else}
  fphttpapp,
{$endif}
  classes, sqldb, httpdefs, httproute, pdfsearcher, fpwebfile;

Type

  { TCorsFileModule }

  TCorsFileModule = Class(TFPCustomFileModule)
    Procedure HandleRequest(ARequest: TRequest; AResponse: TResponse); override;
  end;

Var
  aSearch : TSearcher;

{ TCorsFileModule }


procedure TCorsFileModule.HandleRequest(ARequest: TRequest; AResponse: TResponse
  );
begin
  Cors.Enabled:=true;
  if Cors.HandleRequest(aRequest,aResponse) then exit;
  inherited HandleRequest(ARequest, AResponse);
end;


Procedure ConfigureApp;

begin
  DefaultFileModuleClass:=TCorsFileModule;
  aSearch:=TSearcher.Create(Application);
  aSearch.Init;
//  aSearch.AllowCors:=True;
  sqldb.GlobalDBLogHook:=@aSearch.DoDBLog;
  HTTPRouter.RegisterRoute('/search',@aSearch.PDFSearch,true);
  HTTPRouter.RegisterRoute('/list',@aSearch.WordList,False);
  RegisterFileLocation('pdf',aSearch.PDFLocation);
end;

begin
  ConfigureApp;
  {$ifndef usecgi}
  Application.Port:=3010;
  {$endif}
  Application.Initialize;
  Application.Run;
  ASearch.Free;
end.

